<?php
declare(strict_types=1);

namespace Inti\Wp\Handler;

use Inti\Wp\Middleware\WpBootstrap;
use Psr\Container\ContainerInterface;
use Psr\Http\Server\MiddlewareInterface;
use Laminas\Stratigility\Middleware\RequestHandlerMiddleware;
use Laminas\Stratigility\MiddlewarePipe;

/**
 * Class WordPressMiddlewareFactory
 *
 * @package Inti\Wp
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp
 */
final class WpHandlerFactory
{
    /**
     * @param ContainerInterface $container
     * @return MiddlewareInterface
     */
    public function __invoke(ContainerInterface $container): MiddlewareInterface
    {
        $middleware = new MiddlewarePipe();

        $middleware->pipe($container->get(WpBootstrap::class));
        $middleware->pipe(new RequestHandlerMiddleware(new WpHandler()));

        return $middleware;
    }
}
